<template>
  <mt-box padding="0">
    <b-tabs v-model="activeTab" class="mt-box-onglet" multiline @change="changeTab">
      <b-tab-item label="Identité">
        <mt-fiche-utilisateur>
          <div class="cell-pastille row-3 row-1-mobile is-hidden-mobile">
            <mt-pastille size="43px">{{ utilisateur.initial }}</mt-pastille>
          </div>

          <div class="cell-nom column-2 ">
            <span class="has-text-weight-bold is-size-4">
              <mt-utilisateur :utilisateur="utilisateur"
                ><b-icon v-if="!utilisateur.enabled" icon="lock"
              /></mt-utilisateur>
            </span>
            <div class="columns mt-profil-list">
              <span
                v-for="userProfil in utilisateur.userProfils"
                :key="`userProfil${userProfil.id}`"
                class="column is-narrow is-capitalized is-size-6"
                >{{ userProfil.profil.description }}</span
              >
            </div>
          </div>

          <div class="cell-flag row-2 is-hidden-mobile">
            <b-icon icon="flag"></b-icon>
          </div>

          <div class="cell-generique column-2-mobile">
            <ul>
              <li v-for="organisme in organismes" :key="organisme.id">
                {{ organisme.libelle }}
              </li>
            </ul>
          </div>

          <div class="cell-generique column-2-mobile">
            <div>{{ utilisateur.email }}<br />{{ utilisateur.telephone }}</div>

            <nuxt-link
              v-if="!noModification"
              :to="profilLink({ name: 'pax-id-editer', params: { id: utilisateur.id } })"
            >
              <b-button class="mt-button is-size-8 has-text-weight-semibold" type="is-primary">
                Modifier les informations
              </b-button>
            </nuxt-link>
          </div>

          <div class="cell-separateur column-3">
            <hr />
          </div>

          <div class="column-2 column-1-mobile"></div>
          <div class="cell-generique column-2-mobile">
            <mt-groupes :groupes="utilisateur.groupes" :limit="10"></mt-groupes>
          </div>
        </mt-fiche-utilisateur>
      </b-tab-item>
      <b-tab-item :label="`Activités (${activites.totalElements})`">
        <article class="mt-box-content">
          <form @submit.prevent="moisSelectionne">
            <b-message type="is-danger" size="is-small" class="is-size-7" :active="dateInError">
              La date de fin est antérieure à la date de début
            </b-message>
            <section class="mt-fields-section columns">
              <b-field label="Début de la période" class="column is-one-third">
                <b-datepicker
                  :value="startActivite"
                  placeholder="Sélectionnez une date de debut"
                  :first-day-of-week="1"
                  :month-names="monthNames"
                  :day-names="dayNames"
                  :date-parser="dateParse"
                  editable
                  icon="calendar-today"
                  class="mt-input"
                  @input="debutSelectionne"
                />
              </b-field>
              <b-field label="Fin de la période" class="column is-one-third">
                <b-datepicker
                  :value="endActivite"
                  placeholder="Sélectionnez une date de fin"
                  :first-day-of-week="1"
                  :month-names="monthNames"
                  :day-names="dayNames"
                  :date-parser="dateParse"
                  editable
                  icon="calendar-today"
                  class="mt-input"
                  @input="finSelectionne"
                />
              </b-field>
              <b-switch v-model="onlyActivitesRealisees" class="column is-offset-1 mt-swith" @input="getListActivites"
                >Activités réalisées</b-switch
              >
            </section>
          </form>
          <mt-list v-slot="{ item: activite }" :list="listeActivites">
            <mt-list-item :row-class="resolveTypeActivite(activite, 'mt-list-item-no-table').class">
              <article
                v-if="utilisateur.affectation.organisme.id == activite.organisme.id"
                class="columns is-vcentered"
              >
                <div class="column no-wrap">
                  <nuxt-link :to="profilLink({ name: 'activites-id', params: { id: activite.id } })">
                    <mt-date-range-short
                      class="is-uppercase has-text-weight-bold"
                      :start="activite.dateDebut"
                      :end="activite.dateFin"
                    />
                  </nuxt-link>
                </div>
                <div class="column is-one-third">
                  <nuxt-link :to="profilLink({ name: 'activites-id', params: { id: activite.id } })">
                    {{ activite.nom }}
                  </nuxt-link>
                </div>
                <div class="column columns is-centered no-wrap">
                  <nuxt-link :to="profilLink({ name: 'activites-id', params: { id: activite.id } })">
                    <span class="mt-statut">{{ statut(activite.participants[0]) }}</span>
                  </nuxt-link>
                </div>
                <div class="column no-wrap is-2 progressActivite">
                  <nuxt-link :to="profilLink({ name: 'activites-id', params: { id: activite.id } })">
                    <mt-progress-activity :activite="activite" />
                    <div class="has-text-grey is-size-7">
                      {{ activite.avancement.taux.nombre }} / {{ activite.avancement.taux.total }}
                    </div>
                  </nuxt-link>
                </div>
              </article>
              <b-tooltip
                v-else
                class="columns is-vcentered"
                label="Activité d'une ancienne affectation"
                type="is-light"
              >
                <div class="column no-wrap">
                  <mt-date-range-short
                    class="is-uppercase has-text-weight-bold"
                    :start="activite.dateDebut"
                    :end="activite.dateFin"
                  />
                </div>
                <div class="column is-one-third">
                  {{ activite.nom }}
                </div>
                <div class="column columns is-centered no-wrap">
                  <span class="mt-statut">{{ statut(activite.participants[0]) }}</span>
                </div>
                <div class="column no-wrap is-2 progressActivite"></div>
              </b-tooltip>
            </mt-list-item>
          </mt-list>
        </article>
      </b-tab-item>
      <b-tab-item label="Disponibilités">
        <mt-chevron type="left" title="mois précédent" @click="$emit('mois-precedent')"></mt-chevron>
        <div class="mt-box-activites-header">
          <div class="is-half-mobile mt-controle is-hidden-tablet has-text-weight-semibold">
            <b-field>
              <b-radio-button
                v-model="isAnnuel"
                native-value="annuelle"
                type="is-primary"
                class="mt-floating-button large"
              >
                <a>Année</a>
              </b-radio-button>
              <b-radio-button
                v-model="isAnnuel"
                native-value="mensuel"
                type="is-primary"
                class="mt-floating-button large"
              >
                <a>Mois</a>
              </b-radio-button>
            </b-field>
          </div>
          <div class="columns is-mobile is-vcentered">
            <div class="column is-half-mobile mt-controle is-hidden-mobile has-text-weight-semibold">
              <b-field>
                <b-radio-button
                  v-model="isAnnuel"
                  native-value="annuelle"
                  type="is-primary"
                  class="mt-floating-button large"
                >
                  <a>Année</a>
                </b-radio-button>
                <b-radio-button
                  v-model="isAnnuel"
                  native-value="mensuel"
                  type="is-primary"
                  class="mt-floating-button large"
                >
                  <a>Mois</a>
                </b-radio-button>
              </b-field>
            </div>
            <div class="column is-narrow mt-padding-0">
              <mt-chevron type="left" title="mois précédent" is-mobile @click="$emit('mois-precedent')"></mt-chevron>
            </div>
            <div class="mt-datepicker column is-narrow columns is-vcentered is-two-thirds-mobile">
              <b-datepicker
                class="cursor-as-pointer"
                :value="monthDate"
                :date-formatter="dateFormatter"
                type="month"
                :month-names="monthNames"
                icon="menu-down"
                :mobile-native="false"
                expanded
                @input="moisSelectionne"
              ></b-datepicker>
            </div>
            <div class="column is-narrow mt-padding-0">
              <mt-chevron type="right" is-mobile title="mois suivant" @click="$emit('mois-suivant')"></mt-chevron>
            </div>
          </div>
        </div>
        <vue-cal
          v-if="isAnnuel === 'mensuel'"
          locale="fr"
          :disable-views="['years', 'year', 'week', 'day']"
          default-view="month"
          hide-view-selector
          hide-title-bar
          events-on-month-view
          :dbl-click-to-navigate="false"
          :cell-click-hold="false"
          :selected-date="monthDate"
          style="min-height: 540px"
        >
          <template #weekday-heading="{ heading: { label } }">
            <span class="is-size-8 has-text-weight-bold is-uppercase">{{ label.substr(0, 3) }}.</span>
          </template>
          <template #cell-content="{ cell }">
            <div class="mt-cell-date-parent">
              <div class="mt-cell-overlay" :class="css(cell.formattedDate)"></div>
              <div class="mt-cell-date columns is-mobile">
                <div class="column mt-date-wrapper is-narrow">
                  <div class="mt-date" :class="{ 'mt-is-today': cell.today }">
                    {{ cell.content }}
                  </div>
                </div>
                <mt-disponibilite-employe :disponibilite-employe="disponibilitesEmploye[cell.formattedDate]" />
              </div>
            </div>
          </template>
        </vue-cal>

        <section v-if="isAnnuel === 'annuelle'" class="mt-calendar-annuel">
          <section v-for="(mois, index) in disponibilitesAnnuel" :key="`mois${index}`" class="mt-calendar-annuel-month">
            <h2>
              {{ mois.mois }}
            </h2>
            <section class="mt-calendar-annuel-weeks">
              <article v-for="(day, indexD) in days" :key="`days-${index}-${indexD}`" class="day-of-week">
                {{ day }}
              </article>
              <template v-for="(semaine, indexSemaine) in mois.semaines">
                <article
                  v-for="jour in semaine.jours"
                  :key="`${mois.mois}-day-${indexSemaine}-${jour.jour}`"
                  class="mt-calendar-annuel-day"
                >
                  <article class="jour-dispo" :class="{ 'not-in-month': notInMonth(jour, mois) }">
                    <div class="day" :class="{ 'mt-today': jour.today }">
                      {{ jour.jour }}
                    </div>
                    <mt-disponibilite-puce
                      v-if="jour.disponibilite"
                      :type-disponibilite="jour.disponibilite.typeDisponibilite"
                      size="0.35rem"
                    ></mt-disponibilite-puce>
                  </article>
                </article>
              </template>
            </section>
          </section>
        </section>

        <mt-chevron type="right" title="mois suivant" @click="$emit('mois-suivant')"></mt-chevron>
      </b-tab-item>
      <b-tab-item label="Statistiques">
        <mt-fiche-utilisateur-statistique
          :start="startActivite"
          :end="endActivite"
          :statistique="statistique"
          :type-activite="typeActivite"
          :utilisateur="utilisateur"
          @changeDate="changeDate"
        />
      </b-tab-item>
    </b-tabs>
  </mt-box>
</template>

<script>
import VueCal from 'vue-cal';
import 'vue-cal/dist/i18n/fr';
import 'vue-cal/dist/vuecal.css';
import { DateTime, Info } from 'luxon';
import MtChevron from '~/components/base/chevron/index';
import MtGroupes from '~/components/pax/mt-groupes';
import MtUtilisateur from '~/components/pax/mt-utilisateur';
import MtPastille from '~/components/base/pastille/index';
import MtFicheUtilisateur from '~/components/utilisateur/fiche-utilisateur';
import MtBox from '~/components/base/box';
import MtDisponibiliteEmploye from '~/components/calendar/cell-content/disponibilite-employe';
import MtList from '~/components/base/list/index';
import MtDateRangeShort from '~/components/activity/date-range-short';
import MtProgressActivity from '~/components/activity/progress-users-activity';
import MtListItem from '~/components/base/list/list-item';
import { classResolver } from '~/components/mixins/activityMixin';
import DayMonthMixin from '~/components/mixins/DayMonthMixin';
import MtDisponibilitePuce from '~/components/disponibilite/disponibilite-puce';
import MtFicheUtilisateurStatistique from '~/components/utilisateur/fiche-utilisateur-statistique';

export default {
  name: 'MtDetailsUtilisateur',
  components: {
    VueCal,
    MtList,
    MtListItem,
    MtDateRangeShort,
    MtProgressActivity,
    MtBox,
    MtFicheUtilisateur,
    MtPastille,
    MtUtilisateur,
    MtGroupes,
    MtChevron,
    MtDisponibiliteEmploye,
    MtDisponibilitePuce,
    MtFicheUtilisateurStatistique,
  },
  mixins: [classResolver, DayMonthMixin],
  props: {
    noModification: Boolean,
    utilisateur: {
      type: Object,
      default: () => ({}),
      required: true,
    },
    organismes: {
      type: Array,
      default: () => [],
      required: true,
    },
    disponibilites: {
      type: Array,
      default: () => [],
      required: true,
    },
    activites: {
      type: Object,
      default: () => ({}),
      required: true,
    },
    monthDate: {
      type: Date,
      default: () => null,
      required: true,
    },
    disponibilitesEmploye: {
      type: Array,
      default: () => [],
      required: true,
    },
    startActivite: {
      type: Date,
      default: () => null,
      required: true,
    },
    endActivite: {
      type: Date,
      default: () => null,
      required: true,
    },
    disponibilitesAnnuel: {
      type: Array,
      default: () => [],
    },
    statistique: {
      type: Object,
      default: () => ({}),
    },
    typeActivite: {
      type: Array,
      default: () => [],
    },
  },
  data() {
    return {
      onlyActivitesRealisees: false,
      listeActivites: this.activites.content,
      isAnnuel: 'mensuel',
      days: Info.weekdays('narrow', { locale: 'fr-FR' }),
      activeTab: 0,
    };
  },
  computed: {
    dateInError() {
      if (!this.startActivite || !this.endActivite) {
        return false;
      }
      return (
        !DateTime.fromJSDate(this.startActivite).hasSame(DateTime.fromJSDate(this.endActivite), 'day') &&
        this.endActivite < this.startActivite
      );
    },
  },
  watch: {
    activites: {
      handler() {
        this.getListActivites();
      },
    },
  },
  methods: {
    resolveClass(row) {
      return this.resolveTypeActivite(row, 'mt-list-item-').class;
    },
    css(date) {
      const dispo = this.disponibilitesEmploye[date];
      if (!dispo) {
        return 'mt-is-employe-vide';
      }
      return '';
    },
    statut({
      dernierAvancement: {
        choix: {
          statut: { nomSingulier },
        },
      },
    }) {
      return nomSingulier;
    },
    dateFormatter(date) {
      return DateTime.fromJSDate(date)
        .setLocale('fr')
        .toFormat('LLLL y');
    },
    moisSelectionne(date) {
      this.$emit('mois-selectionne', date);
    },
    debutSelectionne(date) {
      this.$emit('debut-selectionne', date);
    },
    finSelectionne(date) {
      this.$emit('fin-selectionne', date);
    },
    changeDate({ dateDebut, dateFin }) {
      this.debutSelectionne(dateDebut);
      this.finSelectionne(dateFin);
    },
    changeTab() {
      if (this.activeTab === 3) {
        this.$emit('debut-selectionne', this.startActivite);
      }
    },
    getListActivites() {
      if (!this.onlyActivitesRealisees) {
        this.listeActivites = this.activites.content;
      } else {
        this.listeActivites = [];
        for (let i = 0; i < this.activites.content.length; i += 1) {
          if (this.activites.content[i].participants[0].dernierAvancement.choix.code === 'activite-realisee') {
            this.listeActivites.push(this.activites.content[i]);
          }
        }
      }
    },
    notInMonth({ mois }, { numero }) {
      return mois !== numero;
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
@import '~/assets/css/calendar.scss';

.mt-box {
  min-height: 60vh;
}
a {
  display: flex;
  align-items: baseline;
}
/deep/ .progressActivite {
  .progress {
    height: 0.5rem;
    width: 50px;
    margin-right: 15px;
  }

  .progress-wrapper:not(:last-child) {
    margin-bottom: 0;
  }
}
.mt-profil-list {
  color: $grey-light;

  .column {
    margin-right: 1em;
  }
}
.mt-calendar-annuel {
  display: grid;
  grid-template-columns: repeat(auto-fill, minmax(260px, 1fr));
  gap: 1rem;
  flex-wrap: wrap;
  margin: 0rem;
  padding-top: 1rem;
  padding-bottom: 1rem;
}
.mt-calendar-annuel-month {
  display: flex;
  flex-direction: column;
  box-shadow: 0 2px 6px 0 #efefef;
  border-radius: 4px;
  padding: 0.5rem 1rem;

  h2 {
    text-align: center;
    text-transform: uppercase;
    font-size: 0.875rem;
    font-weight: bold;
    color: #5f5f5f;
    cursor: default;
  }
}
.mt-calendar-annuel-weeks {
  display: grid;
  grid-template-columns: repeat(7, 1fr);
}
.mt-calendar-annuel-day {
  display: flex;
  flex-direction: column;
  flex-grow: 1;
  text-align: center;
  padding-bottom: 0.25em;
}
.mt-calendar-annuel-day:nth-child(7n - 1) .jour-dispo,
.mt-calendar-annuel-day:nth-child(7n) .jour-dispo {
  opacity: 0.5;

  &.not-in-month {
    opacity: 0.1;
  }
}
.day {
  font-size: 0.875rem;
  color: #5f5f5f;
  cursor: default;
  padding: 0.2em 0.4em;
  border-radius: 50%;
  min-width: 1.8em;
  text-align: center;

  &.mt-today {
    color: white;
    background-color: $primary;
  }
}
.jour-dispo {
  align-self: center;
  justify-self: end;

  display: flex;
  position: relative;
  flex-direction: row;
  align-items: center;

  /deep/ .mt-disponibilite-puce {
    position: absolute;
    right: -0.35rem;
  }
}
.mt-calendar-annuel-activite {
  min-height: 4px;
  margin-bottom: 2px;
  font-size: 0.5rem;
  position: relative;

  &:hover {
    .mt-pop-up-activite {
      display: flex;
      flex-direction: column;
      align-items: flex-start;
    }
  }

  &.not-in-month:hover {
    opacity: 1;
  }
}
.day-of-week {
  color: #aeaeae;
  font-size: 0.75rem;
  text-align: center;
  margin: 0.3em 0;
}
.mt-is-start-day {
  border-bottom-left-radius: 4px;
  border-top-left-radius: 4px;
  margin-left: 1px;
}
.mt-is-end-day {
  border-bottom-right-radius: 4px;
  border-top-right-radius: 4px;
  margin-right: 1px;
}
.not-in-month {
  opacity: 0.2;
}
/deep/ .control.mt-floating-button {
  .button {
    box-shadow: 0 2px 8px -2px rgba(159, 159, 159, 0.5);
    border: none;

    a {
      color: $primary;
    }

    &.is-primary {
      a {
        color: $white;
      }
    }
  }

  &.large .button a {
    padding: 1em;
  }
}
/deep/ .mt-statut {
  cursor: pointer;
}
.mt-box-content {
  padding: 1rem 2rem;
}
</style>
